// -*- mode: objc; tab-width: 4 -*-

// This class is specialized for Byeoroo and will be of little use for
// other programs.

#import  "KText.h"

@interface HistoryText : KText
{
	Widget sink;
	Dimension max_width;
	Position left_margin;
	Position right_margin;
	BOOL resize;
}

- initFromKDF:(char *)kdf_path withWidget:(Widget)text translator:(Widget)tw;

- receiveEvent:(XEvent *)ev;
- (char *)getComposingChar;
- (EventMask)getTextEventMask;
- setLeftMargin:(Position)num;
- setRightMargin:(Position)num;
- (KeyboardType)getKeyboard;
- setString:(char *)string;
- setMaxWidth:(Dimension)width;
- setResize:(BOOL)yesno;

//
//  private methods
//

- makeCaretVisible;
- resize;

- (void)textNextLine:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textPreviousLine:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textNextPage:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textPreviousPage:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textBeginningOfFile:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textEndOfFile:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textScrollOneLineUp:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textScrollOneLineDown:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textNewlineAndIndent:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textNewlineAndBackup:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textNewline:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textInsertFile:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textSearch:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textFormParagraph:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textInsertFileAction:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textDoSearchAction:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textDoReplaceAction:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;
- (void)textPopdownSearchAction:(Widget)w :(XEvent *)ev :(String *)p :(Cardinal *)np;

@end
