// -*- mode: objc; tab-width: 4 -*-

#import  <objc/Object.h>
#include <X11/Xlib.h>
#include <IMdkit.h>

#include "types.h"

@class IContext;

@interface ICManager : Object
{
	IContext **ic_array;
	int array_size;
}

- init;
- free;							// frees all the element IC's and itself.
- add:(IContext *)anIC;			// adds anIC to ic_array[] and
								// sets its icid to a unique value.
- deleteICWithID:(ICIDType)icid;
- (IContext *)findICWithID:(ICIDType)icid;

// private methods

- (ICIDType)generateNewID;
- (int)emptyIndex;

@end
