// -*- mode: objc; tab-width: 4 -*-

#import  <objc/Object.h>
#define  XK_KOREAN
#include <X11/keysym.h>

#define MAXKEYSPERCHAR 10
#define MAXCANDIDATES  6

typedef enum {
	NSTART,
	NCHO1 , NCHO2 , NCHO3 , NCHO4 ,
	NJUNG1, NJUNG2, NJUNG3, NJUNG4,
	NJONG1, NJONG2, NJONG3, NJONG4
} CompositionState;

typedef unsigned int JamoKey;

typedef struct {
	JamoKey jamo_key;
	int state_offset;
} JamoKeyAndStateOffset;
	
enum { JUSTFINE, CHARBREAK, EMPTY, WRONGKEY, OVERFLOW };

@interface KAutomataCore : Object
{
@private
	char composed_char[3];		// in 2 byte johab code
	char composing_char[3];		// in 2 byte johab code
	CompositionState state;
	int num_elected_keys;
	JamoKey elected_keys[MAXKEYSPERCHAR+1];
	CompositionState history[MAXKEYSPERCHAR+1];
	JamoKeyAndStateOffset cand_list_save[MAXKEYSPERCHAR+1][MAXCANDIDATES];
}

- init;

// keyCandidateList is terminated by an element whose jamo_key member
// is 0 if the number of elements is less than MAXCANDIDATES.
// If the number is MAXCANDIDATES, no terminating sign is needed.
- (int)eatKey:(JamoKeyAndStateOffset *)keyCandidateList;
- (int)deleteLastKey;
- (char *)getComposedChar;
- (char *)getComposingChar;
- clear;

// private methods

- reset;

@end
