// -*- mode: objc; tab-width: 4 -*-

#include <X11/X.h>
#include <X11/Xlib.h>

#import "KAutomataCore.h"

struct keycode_to_jamokey_map {
	// map from
	KeyCode keycode;
	unsigned int modifier;
	unsigned int modifier_mask;
	// to
	JamoKeyAndStateOffset candidates[MAXCANDIDATES];
};

// This function must be called once before any KAutomataForX instance
// initialization.
BOOL retrieve_keyboard_mapping(Display *display);

// Returns YES if keycode is a modifier.
// Returns NO otherwise.
BOOL is_modifier(KeyCode keycode);

@interface KAutomataForX : KAutomataCore
{
@private
	char composed_chars[4];		// one Korean char and one possible ASCII char
	int njamokeys;
	struct keycode_to_jamokey_map *map;
}

- init;							// this must not be called.
- initFromFile:(char *)path on:(Display *)display;
- free;

- (int)eatKeycode:(KeyCode)keycode modifier:(unsigned int)modifier;
- (char *)getComposedChar;

// private methods

- readKDF:(char *)file whoseSize:(int)size;

@end
