/* -*- mode: c; tab-width: 4 -*- */

#include "hangul.h"
#include "XJohab.h"

#define STRBUFLEN 64

int XTextWidthJohab(XFontStruct *fs, XFontStruct *jfs,
					char *s, int n)
{
	int width = 0;
	XChar2b buf[STRBUFLEN];
	char *p;

	for (; n > 0; s = p) {
		if (*s & CMSB) {		/* Korean */
			int l;
			
			for (p = s; n > 0 && p - s < STRBUFLEN*2/3 && *p & CMSB;
				 p += 2, n -= 2)
				;
			l = convert_johab_to_display(s, buf, p - s);
			width += XTextWidth16(jfs, buf, l);
		}
		else {					/* ASCII */
			for (p = s; n > 0 && !(*p & CMSB); p++, n--)
				;
			width += XTextWidth(fs, s, p - s);
		}
	}

	return width;
}

void XDrawStringJohab(Display *display, Drawable d, GC gc, GC jgc,
					  XFontStruct *fs, XFontStruct *jfs,
					  int x, int y, char *s, int n)
{
	XChar2b buf[STRBUFLEN];
	char *p;

	for (; n > 0; s = p) {
		if (*s & CMSB) {		/* Korean */
			int l;
			
			for (p = s; n > 0 && p - s < STRBUFLEN*2/3 && *p & CMSB;
				 p += 2, n -= 2)
				;
			l = convert_johab_to_display(s, buf, p - s);
			XDrawString16(display, d, jgc, x, y, buf, l);
			x += XTextWidth16(jfs, buf, l);
		}
		else {
			for (p = s; n > 0 && !(*p & CMSB); p++, n--)
				;
			XDrawString(display, d, gc, x, y, s, p - s);
			x += XTextWidth(fs, s, p - s);
		}
	}
}
