/* -*- mode: objc; tab-width: 4 -*- */

#ifndef _BYEOROO_H_
#define _BYEOROO_H_

#include <X11/Xlib.h>
#include <IMdkit.h>
#include <Xi18n.h>
#include "Intrinsic.h"
#import  "IContext.h"
#include "types.h"

#define APPCLASS  "Byeoroo"
#define IMSNAME   "byeoroo"
#define IMSLOCALE "ko_KR"
#define FILTEREVENTMASK KeyPressMask

#define KDFEXT    ".kdf"
#define KTTEXT    ".ktt"

#define SPECIAL_IN_JOHAB "\xcb\x62"

struct app_data {
	char *transport;
	char *toggle_key;
	char *chinese_key;
	char *popup_key;
	char *search_path;
	char *default_kdf;
};

enum { TOGGLE, POPUP, CONVERSION };	// trigger key index

extern struct app_data app_data;
extern XtAppContext app_context;
extern XIMS ims;
extern Display *display;
extern XOM om;
extern IContext *focusedIC;
extern IContext *lastFocusedIC;
extern BOOL cp_popped_up;

// Main window widgets
extern Widget topLevel;
extern Widget box;	
extern Widget korEngStat;
extern Widget charLineStat;
extern Widget kdfLabel;
extern Widget kttLabel;

// Control panel widgets
extern Widget cpshell;
extern Widget cpform;
extern Widget cptitle;
extern Widget cplabel1;
extern Widget cplabel2;
extern Widget cplabel3;
extern Widget cpchar;
extern Widget cpline;
extern Widget cpkdf;
extern Widget cpktt;
extern Widget cpokay;
extern Widget cpcancel;
extern Widget cplistshell;
extern Widget cplist;

void install_actions();
void install_translations();
int trigger_key_index(XKeyEvent *kev);
void print_e(int exit_code, char *format, ...);

#endif /* _BYEOROO_H_ */
